unit BonusUnit;

// les images proviennent du site https://icones8.fr/icons

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf,
  FireDAC.Stan.StorageBin, FMX.ListView.Types, FMX.ListView.Appearances,
  FMX.ListView.Adapters.Base, FMX.ListView, FMX.Objects, FMX.StdCtrls,
  FMX.Controls.Presentation, FMX.TabControl, Data.Bind.Components,
  Data.Bind.DBScope, Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  Data.Bind.EngExt, Fmx.Bind.DBEngExt, System.Rtti, System.Bindings.Outputs,
  Fmx.Bind.Editors, System.ImageList, FMX.ImgList;

type
  TBonus = class(TForm)
    FDMemTable1: TFDMemTable;
    FDMemTable1CustNo: TFloatField;
    FDMemTable1Company: TStringField;
    FDMemTable1Country: TStringField;
    BindSourceDB1: TBindSourceDB;
    Panneaux: TTabControl;
    RealLife: TTabItem;
    ToolBar1: TToolBar;
    Premier: TSpeedButton;
    Suivant: TSpeedButton;
    Prcdent: TSpeedButton;
    Text1: TText;
    ListViewReal: TListView;
    Menu: TTabItem;
    ListViewMenu: TListView;
    BindingsList1: TBindingsList;
    LinkFillControlToField: TLinkFillControlToField;
    LinkFillControlToField5: TLinkFillControlToField;
    LinkFillControlToField6: TLinkFillControlToField;
    ImageList1: TImageList;
    procedure ListViewRealItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure PremierClick(Sender: TObject);
    procedure SuivantClick(Sender: TObject);
    procedure PrcdentClick(Sender: TObject);
    procedure ListViewMenuItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure ListViewMenuUpdateObjects(const Sender: TObject;
      const AItem: TListViewItem);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Bonus: TBonus;

implementation

{$R *.fmx}

procedure TBonus.ListViewMenuItemClick(const Sender: TObject;
  const AItem: TListViewItem);
var AnItem : TListViewItem;
    i : Integer;
begin
if AItem.Purpose=TListItemPurpose.Header then
 begin
   if AItem.Tag=0 then AItem.Tag:=1 else AItem.Tag:=0;
   for  I:= AItem.Index+1  to listviewmenu.items.count-1 do
    begin
     AnItem:=ListViewMenu.Items[i];
     if AnItem.Purpose=TListItemPurpose.Header then Break;
     if AItem.Tag=0 then AnItem.Height:=44 else AnItem.Height:=1;
     AnItem.Objects.TextObject.Visible:=AItem.Tag=0;
    end;
   AItem.Objects.ImageObject.Bitmap.Rotate(180); // dans le cas d'une flche une rotation  180 suffit
//     AItem.Objects.ImageObject.Bitmap:=ImageList1.Bitmap(TSizeF.Create(32,32),AItem.tag);
 end;
end;

procedure TBonus.ListViewMenuUpdateObjects(const Sender: TObject;
  const AItem: TListViewItem);
//  NOTE
// il serait mieux de ne charger qu'une seule fois la ressource dans un Stream
// de mme s'il s'agit d'un fichier
// d'o "l'avantage" de la liste d'image quoique, si l'on utilise un MultiResBitmap on se retrouvera dans le mme cas
var aStream: TResourceStream;
begin
// Chargement d'une ressource
if AItem.Purpose=TListItemPurpose.Header then
  begin
     aStream := TResourceStream.Create(HInstance,'fleche',RT_RCDATA);
      try
        AItem.Objects.ImageObject.Bitmap.LoadFromStream(aStream);
     finally
       aStream.Free;
    end;
// Chargement fichier "externe"
//    AItem.Objects.ImageObject.Bitmap.LoadFromFile('..\..\fleche.png');
// Utilisation TImageList
//    AItem.Objects.ImageObject.Bitmap:=ImageList1.Bitmap(TSizeF.Create(32,32),0);
  end;
end;

procedure TBonus.ListViewRealItemClick(const Sender: TObject;
  const AItem: TListViewItem);
var  AListItemText : TListItemText;
     AButton       : TListItemTextButton;
begin
if AItem.Purpose=TListItemPurpose.None then
  begin
   if not ListViewReal.EditMode then
    ListViewReal.Items.SetChecked(AItem.Index,not Aitem.Checked);
    AListItemText:=AItem.Objects.TextObject;
    if AItem.Checked
        then AListItemText.Font.Style:=[TFontStyle.fsBold]
       else AListItemText.Font.Style:=[];
   end;
end;

procedure TBonus.PremierClick(Sender: TObject);
begin
If ListViewReal.Items.FirstChecked(True)>-1
  then begin
     ListViewReal.BeginUpdate;
     ListViewReal.Selected:=ListViewReal.Items[ListViewReal.Items.FirstChecked(True)];
     ListViewReal.EndUpdate;
  end;
end;

procedure TBonus.PrcdentClick(Sender: TObject);
var CheckList : TArray<Integer>;
    Index, C : Integer;
begin
Index:=ListViewReal.Selected.Index;
CheckList:=ListViewReal.Items.CheckedIndexes(TListViewItems.TOrder.LastToFirst,True);
ListViewReal.BeginUpdate;
for C in CheckList do
  if C<Index then
    begin
     ListViewReal.Selected:=ListViewReal.Items[C];
     Break;
    end;
ListViewReal.EndUpdate;
end;

procedure TBonus.SuivantClick(Sender: TObject);
var CheckList : TArray<Integer>;
    Index, C : Integer;
begin
Index:=ListViewReal.Selected.Index;
CheckList:=ListViewReal.Items.CheckedIndexes(TListViewItems.TOrder.FirstToLast,True);
ListViewReal.BeginUpdate;
for C in CheckList do
  if C>Index then
    begin
     ListViewReal.Selected:=ListViewReal.Items[C];
     Break;
    end;
ListViewReal.EndUpdate;
end;

end.
